/*
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

// TODO: posix threads console output some menu struct.

/* some common functions */
#include <unistd.h>
#include <stdlib.h>
#include <pthread.h>
#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <dirent.h>

#include "SDL.h"
#include "SDL_image.h"
#include <SDL_thread.h>
#include "SDL_mixer.h"
#include "SDL_ttf.h"

#define WIDTH 960 
#define HEIGHT 540
#define BPP 4
#define DEPTH 32

FILE *log_fp;

/* extern unsigned int GetFrameBufferAddress(void); */

SDL_Event event;
SDL_Rect tmp_rect, cons_rect, cons_offs, cons_capt, video_rect;
SDL_Surface *screen, *bg , *ss_surface, *tmps, *cons, *titlebar, *logo, *logo_ns ;
char res_path[100];
TTF_Font *fntCourier;
SDL_Thread *th_exec = NULL, *th_draw = NULL;

/* some vars for audio */
int audio_rate = 44100;
Uint16 audio_format = AUDIO_S16; /* 16-bit stereo */
int audio_channels = 2;
int audio_buffers = 4096;
/* Mix_Music actually holds the snd information.  */
Mix_Music *bsnd = NULL, *hit = NULL;
/* Mix_Chunk is like Mix_Music, only it's for ordinary sounds. */
Mix_Chunk *snd = NULL, *hit2 = NULL;

/* setup code for fps calculation */
float startclock = 0;
float deltaclock = 0;
float currentFPS = 0;

/* console buffer */
char con_buf[4096];

/* need for pthreads */
#define NUM_THREADS     5
struct thread_data{
	SDL_Surface *t_screen;
	int  sum;
	char *command;
};

void __attribute__ ((constructor)) SGO_init(void);
void __attribute__ ((destructor)) SGO_fini(void);

void DrawScreen(SDL_Surface* screen)
{ 

	if(SDL_MUSTLOCK(screen)) 
	{
		if(SDL_LockSurface(screen) < 0) return;
	}


	SDL_BlitSurface(tmps,0,screen,0);

	if(SDL_MUSTLOCK(screen)) SDL_UnlockSurface(screen);

	SDL_Flip(screen); 
}

void PrintOnConsole(char *txt){
	fprintf(log_fp,"%s\n",txt);
	fflush(log_fp);
}

void exec_cmd(char *cmd){
	char buf[2048];
	FILE *fp;
	int status;
	char ppath[PATH_MAX];

	fprintf(log_fp,"Call Command: %s\n",cmd);

	/* Lock 
	   SDL_SemWait(videoLock); */
	fp = popen(cmd,"r");
	if (fp == NULL)
		fprintf(log_fp,"failed to popen %s\n",cmd);
	/* PrintOnConsole(cmd); */
	while (fgets(ppath, PATH_MAX, fp) != NULL) {
		sprintf(buf,"%s",ppath);
		fprintf(log_fp,"%s", ppath);
		strcat(con_buf,buf);
		PrintOnConsole(buf); 
	}
	/* PrintOnConsole("Script Finished!"); */
	/* realy needed? */
	status = pclose(fp);
	if (status == -1) {
		fprintf(log_fp,"failed to pclose\n");
		/* PrintOnConsole("failed to pclose\n"); */
	} else {
		fprintf(log_fp,"successful pclose\n");
		/* Use macros described under wait() to inspect `status' in order
		 * to determine success/failure of command executed by popen()
		 */
		/* PrintOnConsole("successful pclose\n"); */
	}
	/* Unlock 
	 * SDL_SemPost(videoLock); */
	pthread_exit(NULL);
}

int CleanUp(void){
	/* This is the cleaning up part */
	fprintf(log_fp,"%s\n",__FUNCTION__);
	//      SDL_VideoQuit();
	// fclose(stdlog);
	TTF_Quit();
	// kein ton nach ende? 
	Mix_CloseAudio();
	// SDL_VideoQuit();
	SDL_Quit();
	return 0;
}

int Game_Main(const char *path, const char *udn)
{

	int BgMuChannel = -1;
	int keypress = 0;
	int i,err; 
	char cmd[100];
	char bg_img[100];
	char logo_img[100];
	char logo_ns_img[100];
	char bg_mus[100];
	char sound_f[100];
	char sound_f2[100];

	sprintf(cmd,"%s/rcSGO &\n",path);
	sprintf(bg_img,"%s/Eng_Res/full_bg.bmp",path);
	sprintf(logo_img,"%s/Eng_Res/SamyGOntrolPanel-Trial-01.png",path);
	sprintf(logo_ns_img,"%s/Eng_Res/SamyGOntrolPanel-Trial-01ns.png",path);
	sprintf(bg_mus,"%s/Eng_Res/self.mp3",path);
	sprintf(sound_f,"%s/Eng_Res/SATLLITE.WAV",path);
	sprintf(sound_f2,"%s/Eng_Res/SC_shutdown_sequence.wav",path); 
	/* sprintf(sound_f2,"%s/Eng_Res/SC_start_sequence.wav",path); */

	fprintf(log_fp,"exexute %s\n",cmd);
	fprintf(log_fp,"exexute %s\n",logo_ns_img);

//	err = system(cmd);
	th_exec = SDL_CreateThread( exec_cmd, cmd);

	if (SDL_Init(SDL_INIT_VIDEO|SDL_INIT_AUDIO) < 0 ) return 1;

//	if (!(screen = SDL_SetVideoMode(WIDTH, HEIGHT, DEPTH, SDL_RLEACCEL|SDL_RLEACCELOK|SDL_HWSURFACE)))
	if (!(screen = SDL_SetVideoMode(WIDTH, HEIGHT, DEPTH, SDL_FULLSCREEN)))
	{
		SDL_Quit();
		return 1;
	}

	if(Mix_OpenAudio(audio_rate, audio_format, audio_channels, audio_buffers)) {
		fprintf(log_fp,"Unable to open audio!\n");
		return 1;
	} else {
		Mix_QuerySpec(&audio_rate, &audio_format, &audio_channels);
		fprintf(log_fp,"open audio audio_rate %d audio_format %d audio_channels %d\n",
				audio_rate,audio_format,audio_channels);
		// hit2 = Mix_LoadMUS("/mtd_appdata/resource/factory_reset_bell.mp3");
	}

	SDL_EnableKeyRepeat(60, 150);
	TTF_Init();
	Mix_VolumeMusic(20);

	snd = Mix_LoadWAV(sound_f); /* startmeldung */
	fprintf(log_fp,"Load: %s\n",sound_f);
	hit2 = Mix_LoadWAV(sound_f2);
	fprintf(log_fp,"Load: %s\n",sound_f2);
	bsnd = Mix_LoadMUS(bg_mus);
	Mix_FadeInMusic(bsnd, -1, 4000);
	BgMuChannel = Mix_PlayChannel(-1, snd, 0);
	fprintf(log_fp,"snd at chan %d last SDL error %s\n",BgMuChannel,SDL_GetError());

//	startclock = SDL_GetTicks();
	bg = IMG_Load(bg_img);
	fprintf(log_fp,"Load: %s\n",bg_img);
	tmps = IMG_Load(bg_img);
	fprintf(log_fp,"Load: %s\n",bg_img);
	logo = IMG_Load(logo_img);
	fprintf(log_fp,"Load: %s\n",logo_img);
	logo_ns = IMG_Load(logo_ns_img);
	// SDL_SetAlpha(bg, SDL_SRCALPHA, 10);
	SDL_SetAlpha(tmps, SDL_SRCALPHA, 10);

	tmp_rect.y = 2;
	for(i=0;i<30;i++) {
		SDL_BlitSurface(bg,NULL,tmps,NULL);
//		if (i % 2 == 0 ) {
//			tmp_rect.x = (WIDTH - logo->w) / 2; /* zentriert */
//			SDL_BlitSurface(logo,NULL,tmps,&tmp_rect);
//		} 
		tmp_rect.x = (WIDTH - logo_ns->w) / 2; 
		SDL_BlitSurface(logo_ns,NULL,tmps,&tmp_rect);

		if (i == 18){
			Mix_PlayChannel(-1, hit2, 0);
			SDL_Delay(2000);
			Mix_FadeOutMusic(2000);
			fprintf(log_fp,"fadeout.\n");
		}


		DrawScreen(screen);
		//		deltaclock = SDL_GetTicks() - startclock;
		//		startclock = SDL_GetTicks();
		//		if ( deltaclock != 0 )
		//			currentFPS = 1000 / deltaclock;
		fprintf(log_fp,"FPS %0.2f i %d\n",currentFPS,i);
		SDL_Delay(200);	
	}

	//Wait for the threads to finish 
//	SDL_WaitThread( th_exec, NULL );
//	Mix_PlayChannel(-1, hit2, 0);

	fprintf(log_fp,"ready\n");

	// sdl wird nicht beendet
	// pthread_exit(NULL);	

	return (CleanUp());
}

void SGO_init(void){
	// log_fp = stderr;
	log_fp = fopen("/dtv/libSamyGO.log", "a+");
	fprintf(log_fp,"####################\n");
}
void SGO_fini(void){
	fprintf(log_fp,"%s\n",__FUNCTION__);
	fflush(log_fp);
	fclose(log_fp);

}
